<template>
    <div>
        <canvas ref="canvas" class="fit"/>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import Chart, {ChartType} from "chart.js";
import {ApplyDiff} from "src/classLibrary/Utility";
import {ChartDataSet, Graph, GraphValue, ToChartJs, ToChartPie, ToLineChart} from "src/classLibrary/Charting/DataSet";
import {GraphSetting} from "src/classLibrary/Charting/GraphSetting";
import {
    GenerateLabelSettings,
    GenerateScales,
    GenerateToolTips,
    LabelFormatting
} from "src/classLibrary/Charting/GenerateChartSettings";
import {GraphExportType} from "src/classLibrary/Constants";
import {exportFile} from "quasar";
import {jsPDF} from "jspdf";

Chart.pluginService.register({

    beforeDraw: function (chart: Chart) {
        const options: any | null = chart.config.options;
        const ctx = chart.ctx;
        if (ctx != null) {
            if (options?.chartArea && options?.chartArea?.backgroundColor) {
                ctx.save();
                ctx.fillStyle = options?.chartArea.backgroundColor;
                ctx.fillRect(0, 0, 3840 / 2, 2160 / 2);
                ctx.restore();
            }
            if (chart.config.type === 'doughnut' && options?.kirin?.valueFormat) {
                const cw = chart.chartArea.right - chart.chartArea.left,
                    ch = chart.chartArea.bottom - chart.chartArea.top;
                const w = chart.width, h = chart.height;
                if (w && h && cw && ch) {
                    const {valueFormat, dark} = options.kirin as { valueFormat: GraphValue, dark: boolean };
                    const total = chart.data.datasets?.Map(x => x.data as number[])
                                       .Map(x => x.Sum())
                                       .Sum() ?? 0;
                    const f = LabelFormatting(valueFormat, true);
                    const text = f(total);

                    ctx.restore();
                    const fontSize = (h / 250).toFixed(2);
                    ctx.font = fontSize + "em sans-serif";
                    ctx.fillStyle = dark ? 'white' : 'black';
                    ctx.textBaseline = "bottom";
                    const textX = Math.round((w - ctx.measureText(text).width) / 2),
                        textY = ch / 2 + (h - ch);
                    ctx.fillText(text, textX, textY);
                    ctx.save();


                    ctx.restore();
                    if (options?.kirin?.subtitle) {
                        const subtitle = options?.kirin.subtitle;
                        const fontSize2 = (h / 750).toFixed(2);
                        ctx.font = fontSize2 + "em sans-serif";
                        ctx.textBaseline = "top";
                        ctx.fillStyle = 'grey';
                        const textX2 = Math.round((w - ctx.measureText(subtitle).width) / 2),
                            textY2 = ch / 2 + (h - ch);
                        ctx.fillText(subtitle, textX2, textY2);
                    }
                    ctx.save();
                }
            }
        }
    }
});

@Component
export default class ChartComponent extends Vue {

    async Download(exportType: GraphExportType) {
        return new Promise<void>(r => {
            const canvas = document.createElement('canvas');
            canvas.width = 3840 / 2;
            canvas.height = 2160 / 2;
            canvas.style.backgroundColor = 'white';
            const ctx = canvas.getContext('2d')!;
            ctx.fillStyle = 'white';
            ctx.strokeRect(0, 0, 3840 / 2, 2160 / 2)
            const c = this.createChart(canvas, false, "white");
            this.ApplyChartConfiguration(c);
            const title = this.title.ReplaceAll(" ", "_");
            setTimeout(() => {
                switch (exportType) {
                    case "jpeg":
                        canvas.toBlob((b) => {
                            exportFile(title + ".jpeg", b!, "image/jpeg");
                            canvas.remove();
                            r();
                        }, 'image/jpeg');
                        break;
                    case "png":
                        canvas.toBlob((b) => {
                            exportFile(title + ".png", b!, "image/png");
                            canvas.remove();
                            r();
                        }, 'image/png');
                        break;
                    case "pdf":
                        const pdf = new jsPDF("landscape", "mm", "a4");

                        const imgProps = pdf.getImageProperties(canvas);
                        const pdfWidth = pdf.internal.pageSize.getWidth() - 40;
                        const pdfHeight = (imgProps.height * pdfWidth) / imgProps.width;
                        pdf.addImage(canvas, 20, 20, pdfWidth, pdfHeight);
                        pdf.save(title + ".pdf");
                        canvas.remove();
                        r();
                        break;

                }
            }, 1000)
        });


    }

    @Prop() graph!: Graph
    @Prop() graphSetting!: GraphSetting;
    @Prop() title!: string;
    @Prop() subtitle!: string | null;

    // Diff control
    prevType?: ChartType | null = null;
    chart?: Chart | null = null;

    get Canvas(): HTMLCanvasElement {
        return this.$refs.canvas as any;
    }

    @Watch('graphSetting', {deep: true})
    OnSettingChange() {
        this.DataChange();
    }

    @Watch('$q.dark.mode')
    OnDarkMode() {
        this.DataChange();
    }

    @Watch('graph', {deep: true})
    OnGraphChange() {
        this.DataChange();
    }

    GetAlpha(): number {
        switch (this.graph.type) {
            case "line":
                return this.graphSetting.lineAlpha;
            case "bar":
            case "horizontalBar":
                return this.graphSetting.barAlpha;
            case "radar":
                return this.graphSetting.radarAlpha;
            case "polarArea":
                return this.graphSetting.polarAlpha;
            case "doughnut":
            case "pie":
                return this.graphSetting.pieAlpha;
            case "bubble":
            case "scatter":
                return this.graphSetting.scatterAlpha;
        }
        return 0.3;
    }

    ApplyChartConfiguration(chart: Chart) {
        const tooltips = GenerateToolTips(this.graph);
        const scales = GenerateScales(this.graphSetting.stack, this.graphSetting.shortenDuration, this.graph);
        if (chart.config.options == null) chart.config.options = {};
        const opts = chart.config.options as any;
        if (opts.scales == null) opts.scales = {};
        if (opts.tooltips == null) opts.tooltips = {};
        if (opts.plugins == null) opts.plugins = {};
        if (opts.plugins.datalabels == null) opts.plugins.datalabels = {};

        if (scales == null) {
            delete opts.scales;
        } else {
            opts.scales = scales;
        }
        if (opts.legend == null) opts.legend = {}
        opts.legend.display = this.graphSetting.legend;

        opts.tooltips = tooltips;
        if (opts.title == null) opts.title = {display: true};
        if (opts.kirin == null) opts.kirin = {};
        opts.kirin.dark = this.$q.dark.mode;
        opts.kirin.subtitle = this.subtitle;
        opts.kirin.valueFormat = this.graph.valueType;
        opts.kirin.independentType = this.graph.independentType;
        opts.kirin.dependentType = this.graph.dependentType;
        opts.title.display = this.graphSetting.title
        opts.title.position = this.graphSetting.titlePosition;
        opts.title.fontSize = this.graphSetting.titleFontSize;
        opts.title.fontColor = this.graphSetting.titleColor;
        opts.title.text = this.title;
        opts.plugins.datalabels = GenerateLabelSettings(this.graphSetting, this.graph);

        const type = this.graph.type;

        const colorMode = this.graphSetting.colorMode;
        const alpha = this.GetAlpha();
        const dataset = ChartDataSet.match(this.graph.data, {
            Graph: (g) => {
                if (type === 'pie' || type === 'doughnut')
                    return ToChartPie(g, colorMode, alpha)
                else
                    return ToChartJs(g, colorMode, alpha)
            },
            Matrix: (m) => ToLineChart(m, colorMode, alpha),
        })
        if (type == 'bar') {

            let prefixSum = 0;
            let data = dataset.datasets?.Map(x => x.data as number[])
                              .reduce((a: number[], b: number[]) => a.Map((e, i) => e + b[i]))
                              .map(x => prefixSum += x);
            const ds: Chart.ChartDataSets = {
                label: 'Cumulative',
                backgroundColor: 'transparent',
                borderColor: 'red',
                data,
                yAxisID: 'cumulative-axis',
                type: 'line',
            }
            dataset.datasets?.push(ds);
        }

        ApplyDiff(chart.data.labels, dataset.labels);
        chart.update();


        if (chart.data.datasets != null && dataset?.datasets != null) {
            const currentLength = chart.data.datasets.length;
            const newLength = dataset.datasets.length;
            const diff = (currentLength - newLength).Abs();
            if (currentLength > newLength) {
                for (let i = 0; i < diff; i++) {
                    chart.data.datasets.pop();
                }
            } else if (currentLength != newLength) {
                for (let i = currentLength; i < newLength; i++) {
                    chart.data.datasets.push(dataset.datasets[i]);
                }
            }

            for (let i = 0; i < newLength; i++) {
                chart.data.datasets[i].label = dataset.datasets[i].label;
                chart.data.datasets[i].data = dataset.datasets[i].data;
                if (dataset.datasets[i].type == null) {
                    delete chart.data.datasets[i].type
                } else {
                    chart.data.datasets[i].type = dataset.datasets[i].type;
                }
                if (dataset.datasets[i].yAxisID == null) {
                    delete chart.data.datasets[i].yAxisID
                } else {
                    chart.data.datasets[i].yAxisID = dataset.datasets[i].yAxisID;
                }
                chart.data.datasets[i].backgroundColor = dataset.datasets[i].backgroundColor;
                if (this.graph.type === 'pie' || this.graph.type === 'doughnut') {
                    chart.data.datasets[i].borderColor = this.$q.dark.mode ? '#121212' : 'white';
                    chart.data.datasets[i].borderWidth = 5;

                } else {
                    chart.data.datasets[i].borderColor = dataset.datasets[i].borderColor;
                    chart.data.datasets[i].borderWidth = (this.graph.type === 'line' || dataset.datasets[i].type === 'line') ? this.graphSetting.lineThickness : this.graphSetting.borderThickness;
                }
                chart.data.datasets[i].lineTension = this.graphSetting.tension;

            }
        }

        chart.update();
    }

    DataChange() {
        if (this.chart == null) return;
        if (this.prevType != this.graph.type) {
            this.generateChart();
        }
        this.ApplyChartConfiguration(this.chart);
        this.prevType = this.graph.type;
    }

    createChart(canvas: HTMLCanvasElement, responsive: boolean = true, backgroundColor?: string) {

        const config =
            {

                type: this.graph.type ?? 'bar',
                data: {
                    labels: ['Sample1'],
                    datasets: [
                        {
                            label: 'left',
                            borderColor: 'blue',
                            data: [1]
                        }
                    ]
                },
                options: {
                    title: {
                        display: true,
                        text: 'Hello!',
                    },
                    legend: {
                        display: true
                    },
                    maintainAspectRatio: false,
                    responsive,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },

                }
            };
        if (backgroundColor != null) {
            const x = (config.options as any);
            x.chartArea = {backgroundColor}
        }
        return new Chart(canvas, config as any);
    }

    generateChart() {
        this.chart?.destroy();
        this.chart = this.createChart(this.Canvas)
        // (window as any).chart = this.chart;
    }


    mounted() {
        this.generateChart();
        this.DataChange();
    }
}
</script>

<style lang='scss' scoped>

</style>
